using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Collections.Generic;

namespace aerolized
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			new MainClass().rin(args);
		}
		
		const int LWA_KEY = 1;
		const int LWA_ALPHA = 2;
		[DllImport("user32.dll")]
		static extern bool SetLayeredWindowAttributes(IntPtr hWnd, uint crKey, byte bAlpha, uint dwFlags);
		
		const int GWL_STYLE = -16;
		const int GWL_EXSTYLE = -20;
		const int WS_EX_LAYERED = 0x80000;
		const int WS_CHILD = 0x40000000;
		const int WS_BORDER = 0x800000; // has border
		const int WS_DLGFRAME = 0x400000; // has double border but no title
		const int WS_CAPTION = WS_BORDER | WS_DLGFRAME; // has title bar
		
		[DllImport("user32.dll")]
		static extern int GetWindowLong(IntPtr hWnd, int nIndex);
		[DllImport("user32.dll")]
		static extern bool SetWindowLong(IntPtr hWnd, int nIndex, int dwNewLong);
		
		public void rin(string[] args)
		{
			Console.WriteLine("Hello World!");
			Console.WriteLine("Fetching applications");
			Process[] procraw = Process.GetProcesses();
			List<Process> procs = new List<Process>(procraw);
			for (int a = 0; a < procs.Count; a++)
			{
				if (string.IsNullOrEmpty(procs[a].MainWindowTitle))
				{
					procs.RemoveAt(a--);
				}
			}
			Console.WriteLine("Found " + procs.Count + " windows");
			Console.WriteLine();
			for (int a = 0; a < procs.Count; a++)
			{
				Console.WriteLine("  " + a + "> " + procs[a].MainWindowTitle);
			}

			Console.WriteLine();
			Console.Write("Choose window number> ");
			int window = Convert.ToInt32(Console.ReadLine());
			Process proc = procs[window];
			IntPtr handle = proc.MainWindowHandle;
			Console.WriteLine("Using mwh#" + handle + " of pid#" + proc.Id + " (" + proc.MainWindowTitle + ")");
			
			try
			{
				Console.WriteLine();
				Console.Write("Transparency? YES:(0-255), NO:(letters)> ");
				int opac = Convert.ToInt32(Console.ReadLine());
				
				Console.Write("~GetWindowLong = ");
				int old = GetWindowLong(handle, GWL_EXSTYLE);
				Console.WriteLine(old);
				
				Console.Write("~SetWindowLong = ");
				if (SetWindowLong(handle, GWL_EXSTYLE, old ^ WS_EX_LAYERED))
				{
					Console.WriteLine("OK");
				}
				else
				{
					Console.WriteLine("NOPE");
				}
				Console.Write("~SetLayeredWindowAttribues = ");
				if (SetLayeredWindowAttributes(procs[window].MainWindowHandle, 0, (byte)opac, LWA_ALPHA))
				{
					Console.WriteLine("OK");
				}
				else
				{
					Console.WriteLine("NOPE");
				}
			}
			catch { }
			
			try
			{
				Console.WriteLine();
				Console.Write("Remove borders? YES:(numbers) NO:(letters)> ");
				char mander = (char)Convert.ToInt32(Console.ReadLine());
				
				Console.Write("~GetWindowLong = ");
				int old = GetWindowLong(handle, GWL_STYLE);
				Console.WriteLine(old);
				
				Console.Write("~SetWindowLong = ");
				if (SetWindowLong(handle, GWL_STYLE, old & ~WS_CAPTION))
				{
					Console.WriteLine("OK");
				}
				else
				{
					Console.WriteLine("NOPE");
				}
			}
			catch { }
			
			Console.WriteLine("all done, press enter to exit");
			Console.ReadLine();
		}
	}
}
